struct bspline {
    int n;
    int k;
    float *t;
    float *b;
};

struct splines { 
    int z_projectile;
    float m_projectile;
    int n_nuc;
    int *z_target;
    float *count; 
    float *pot;
    float *m_target;
    float rho;
    int igas;
    float fntp; 
    struct bspline *range_spline;
    struct bspline *rstragg_spline;
    struct bspline *astragg_spline;
    struct bspline *qmean_spline; 
};

int get_atima_spline(const char * file, struct splines *s);
int get_atima_spline_gzipped(const char * file, struct splines *s);
void free_atima_spline(struct splines *s); 
float atima_range(struct splines *s, float energy); 
float atima_enver(struct splines *s, float energy, float thickness); 
float atima_sigra2(struct splines *s, float energy);
float atima_dedx(struct splines *s, float energy);
float atima_domega2de(struct splines *s, float energy);
float atima_da2de(struct splines *s, float energy);
float atima_astragg(struct splines *s, float energy_in, float energy_out);
float atima_qmean(struct splines *s, float energy); 

// functions in C to replace old ATIMA FORTRAN functions, HWE
float e_out2(struct bspline *r, double range,double ei,double thickness);
float bvalue2(struct bspline *r, float x,int jderiv);
void interv2(struct bspline *r, int lxt, float x, int *left, int *mflag);
