#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include "mocadi.h"
#include <string.h>
//#include "cfortran.h"
//#include "hbook.h"
/*
#include "kernlib.h"

  PROTOCCALLSFFUN0(FLOAT,RANF,ranf)
#define RANF() CCALLSFFUN0(RANF,ranf)
*/

/*
 PROTOCCALLSFFUN1(FLOAT,BESK0,besk0,FLOAT)
#define BESK0(A2)  CCALLSFFUN1(BESK0,besk0,FLOAT,A2)

 PROTOCCALLSFFUN1(FLOAT,BESK1,besk1,FLOAT)
#define BESK1(A2)  CCALLSFFUN1(BESK1,besk1,FLOAT,A2)
*/

static int iseed=4895785;
/****************** random genaration *****************/

void random_initialize(int i)
{
  iseed=i;
}

double random_(int *iseed)
{
  (*iseed)*=48828125;
  if((*iseed)<=0){
    (*iseed)+=2147483647;
    (*iseed)++;
  }
  return((double)(*iseed)/(double)2147483648.0);
}

double random_gauss(int *iseed)
{
  static int flag=0;
  static double r1,r2,fact;
  if(flag==0){
  l1:
    r1=random_(iseed);
    if(r1<=0)goto l1;
    r2=random_(iseed);
    fact=sqrt(fabs(-2*log(r1)));
    flag=1;
    return(fact*cos(2*3.141593*r2));
  }
  flag=0;
  return(fact*sin(2*3.141593*r2));
}
/***************** end of random genaration *************/

double prn()
{
  return(random_(&iseed));
  /*
     return(RANF());
     */
}
double rnorm()
{
  return(random_gauss(&iseed));
  /*
     double i;
     return(RG32(i));
     */
}
double rMB(double t)
{
  double x1,x2,x3,x;
  x1=rnorm();
  x2=rnorm();
  x3=rnorm();
  return((x1*x1+x2*x2+x3*x3)*t/2);
}
double rMB2(double t)
{
  double x1,x2,x3,x4,x;
  x1=rnorm();
  x2=rnorm();
  x3=rnorm();
  x4=rnorm();
  return((x1*x1+x2*x2+x3*x3+x4*x4)*t/2);
}
/*
double mmbsk0(int i,double d,int *iret)
{
  return(BESK0((float)d));
  *iret=0;
}
double mmbsk1(int i,double d,int *iret)
{
  return(BESK1((float)d));
  *iret=0;
}
*/

char *get_line(char *line,int n,FILE *fp)
{
  int flag,i;
  for(flag=0;;){
    if(fgets(line,n,fp)==NULL)return(NULL);
    for(i=0;i<n;i++)if(line[i]>0&&line[i]<32)line[i]=' ';
    if(line[0]=='/'&&line[1]=='*')flag=1;
    if(line[0]=='*'&&line[1]=='/')flag=0;
    if(line[0]=='*')continue;
    if(flag==0)return(line);
  }
}

int getparam(char *line,char **arg)
{
  
  int i,j,k;
  
  i=j=0;k=1;
  for(;j<=PARAMETER_MAX;){
  L1:
    if(line[i]==0||line[i]==10)goto exit; 
    if((line[i]==' ')||(line[i]=='\t')){
      i++;
      goto L1;
    }
    if(line[i]==','){
      if(k==0){
	k=1;
	i++;
	goto L1;
      }
      else{
	k=0;
	arg[j++]=&line[i];
	line[i]=0;
	i++;
	continue;
      }
    }
    k=0;
    if(line[i]==0x27){		/* ' */
      arg[j++]=&line[++i];
      while(line[i]!=0x27){
	//	if(line[i]>='A'&&line[i]<='Z')line[i]=line[i]-'A'+'a';
	if(line[i]==0||line[i]==10)goto exit;
	i++;
      }
    }
    else if(line[i]=='"'){
      arg[j++]=&line[++i];
      while(line[i]!='"'){
	//	if(line[i]>='A'&&line[i]<='Z')line[i]=line[i]-'A'+'a';
	if(line[i]==0||line[i]==10)goto exit;
	i++;
      }
    }
    else{
      arg[j++]=&line[i];
      while((line[i]!=' ')&&(line[i]!='\t')&&(line[i]!=',')){
	//	if(line[i]>='A'&&line[i]<='Z')line[i]=line[i]-'A'+'a';
	i++; 
	if(line[i]==0||line[i]==10)goto exit; 
      }
      if(line[i]==',')k=1;
    }
    line[i]=0;
    i++; 
  }
  j=PARAMETER_MAX;
 exit:
  line[i]=0;
  return(j);
}

char asc2ibm(char c)
{
  char out;
  if(c=='.')out=0x4b;
  else if(c=='+')out=0x4e;
  else if(c=='/')out=0x61;
  else if(c>='A'&&c<='I')out=c-'A'+0xC1; 
  else if(c>='J'&&c<='R')out=c-'J'+0xD1;
  else if(c>='S'&&c<='Z')out=c-'S'+0xE2; 
  else if(c>='a'&&c<='i')out=c-'a'+0xC1; 
  else if(c>='j'&&c<='r')out=c-'j'+0xD1; 
  else if(c>='s'&&c<='z')out=c-'s'+0xE2; 
  else if(c>='0'&&c<='9')out=c-'0'+0xF0; 
  else out=0x40;
  return(out);
}
void asc2ibm_string(char *in,char *out,int n)
{
  int i,j;
  j=strlen(in);
  if(n<=j)
    for(i=0;i<n;i++)out[i]=asc2ibm(in[i]);
  else{
    for(i=0;i<j;i++)out[i]=asc2ibm(in[i]);
    for(i=j;i<n;i++)out[i]=0x40;
  }
}
char *tolowers(char line[])
{
  static char line2[257];
  int i;
  for(i=0;i<256;i++){
    if(line[i]==0)break;
    if(line[i]>='A'&&line[i]<='Z')
      line2[i]=line[i]-'A'+'a';
    else
      line2[i]=line[i];
  }
  line2[i]=0;
  return(line2);
}
