/********************************************
 *   define maximum values and constants    *
 ********************************************/
/*
#define MOCADI_DIR "/home/iwasa/mocadi"
#char *MOCADI_DIR="/home/iwasa/mocadi";
char *MOCADI_DIR="/u/weick/mocadi";
*/
#define I_DATA_MAX    1500
#define PARAMETER_MAX   80
#define D_STORE_MAX1    20
#define D_STORE_MAX2    13
#define I_Z_ALL_MAX    500
#define D_TEILCHEN_MAX  14
#define SAVE_MAXNUM     15
#define I_SAVE_MAX     50
/*
#define C_MEM_MAX      100
*/
#define STRING_SIZE    255
#define HBOOK_SIZE 10000000
#define ERWA_MAX       500
#define TR_MATRIX_MAX  400
/*
#define NTUPLE_OFFSET    0
*/
#define HBOOK_OFFSET   100

#define LOOP_MAX 20

#define I_EXT_FUNCTION_MAX 100
#define I_EXT_FUNCTION_OPTPAR_MAX 15
#define I_EXT_FUNCTION_OPTLST_MAX 120

#define d_amu    931.494092 /* CODATA 2018 */
#define d_cligh  2.99792458e10

#define MOCADI_MASS_TABLE_MAX 500
#define D_Z_MAX 150
#define D_N_MAX 200

#define AUDI_MASS_Z_MAX 150
#define AUDI_MASS_N_MAX 250


/*************************
 *   define structures   *
 *************************/

struct s_elmnt{
  struct s_elmnt *p_nxt;
  int z, a_1st, no_ncl; 
  double *ncldata;
};
struct i_table{
  int i_tabsize;
  int **i_tabdata; 
};
struct ew{
  struct ew *p_next_ew;
  int i_cpat;
  char *c_cpat;/*char(i_patlen refer(i_cpat)) */
  int i_ew_result;
  double **d_ew_result;/*(i_tabewlen+i_tabpllen+2 refer(i_ew_result),2)*/
};
struct s_tab{
  int i_zn;
  double **r_ratab; /*( i_n refer(i_zn),2000)*/
  double **r_dedx;  /*( i_n refer(i_zn),2000)*/
  double **r_sigra; /*( i_n refer(i_zn),2000)*/
  double d_enanf;
  double d_enend;
  double d_ensw;
  double d_zatar[3];
};
struct s_matrix{
  double *d_simatrix[7];  /*(6,83)   dec float(16) init( (498) 0 ),*/
  double d_length;
  int icode; /* 1:gios, 2:transp, 3:gico, 4:mirko*/
  int order; 
};

struct fragment_info{
	int charge;
	double mass,
		   relative_yield,
		   relative_events;
};

struct s_ext_function {
  void *handle;
  int (*symbol)(double *,double *,double *,char *);
  char library[STRING_SIZE];
  char name[STRING_SIZE];
  double opt_par[I_EXT_FUNCTION_OPTPAR_MAX];
  char opt_lst[I_EXT_FUNCTION_OPTLST_MAX];
};
struct mocadi_cwn_format {
  int record_length;
  float x[SAVE_MAXNUM],a[SAVE_MAXNUM],y[SAVE_MAXNUM],b[SAVE_MAXNUM],
    energy[SAVE_MAXNUM],time[SAVE_MAXNUM],mass[SAVE_MAXNUM],
    z[SAVE_MAXNUM],elnum[SAVE_MAXNUM],tof[SAVE_MAXNUM],
    de[SAVE_MAXNUM],brho[SAVE_MAXNUM];
  float ratio[SAVE_MAXNUM],range,fragmentation_position;
};




/*************************
 *   define subroutines  *
 *************************/
#ifdef __cplusplus
extern "C"{
#endif
/* functions.c */
/********* random generator ************/
double prn();
double rnorm();
double rMB(double t);
double rMB2(double t);
  void random_initialize(int i);
/********* bessel function *************/
double mmbsk0(int i,double d,int *iret);
double mmbsk1(int i,double d,int *iret);
/********* character separation ********/
char *get_line(char *line,int n,FILE *fp);
int getparam(char *line,char **arg);
/********* IBM interface *************/
char asc2ibm(char c);
void asc2ibm_string(char *in,char *out,int n);
/********* misc **********************/
char *tolowers(char line[]);
/*  BLDLIST.C	*/ 
void bldlist(	char *c_file,
		struct s_elmnt **p_entry);

/*  CHARGE.C	*/
void charge(	int i_element,		/*aktuelle elementnummer*/
		double **d_data,	/*umladungsdaten*/
		double d_teilchen[],	/*teilchenkoordinaten*/
		int i_primcharge,
		int i_chargemax,
		int *i_chpos,
		int *i_error);

/*  EPAXF.C     */
double epaxf(   double d_ap,
                int i_zp,
                double d_at,
                int i_zt,
                double a,
                int i_z);
/*  EPAX3.C     */
double epax3(   double Ap,
		int i_Zp,
		double At,
		int i_Zt,
		double A,
		int i_Z);
/*  ERWAPR1.C	*/
void erwapr1(	int i_ew,
		int i_ewmax,
		int i_ewumlad[],
		int i_charge,
		int i_chargemax,
		char *c_chargepat,
		int i_fragment,
		int i_tablen,
		struct i_table *p_table,
		double **d_erwtab,
		int l_beam,
		double d_sleng[],
		int **i_number,
		int i_rnumber[],
		double ****d_aver,
		char *erwa_name[ERWA_MAX]);

/*  ERWAPRN.C	*/
void erwaprn(	int i_ewmax,
		int i_ewumlad[],
		int i_chargemax,
		char *c_chargepat,
		int i_fragment,
		struct i_table *p_table,
		int l_beam,
		double d_sleng[],
		int **i_number,
		int i_rnumber[],
		double ****d_aver,
		char *erwa_name[ERWA_MAX]);

/*  ERWASUM.C	*/
void erwasum(	double d_teilchen[],
		int i,
		double ****d_aver,
		int **i_number,
		int i_rnumber[],
		int i_chpos);

/*  GEOMET.C	*/
void geomet(	double x,
		double a,
		double y,
		double b,
		int geometry,
		double g1,
		double g2,
		double g3,
		double dx,
		double dy,
		double angle,
		double *d,
		double *d_pro_z,
		double *d_pro_z0);
void  geohom(	double a,
		double b,
		double diameter,
		double *d,
		double *d_pro_z,
		double *d_pro_z0);
void  geowed(	double x,
		double a,
		double y,
		double b,
		double diameter,
		double slope,
		double *d,
		double *d_pro_z,
		double *d_pro_z0);
void  geowir(	double x,
		double a,
		double y,
		double b,
		double diameter,
		double distance,
		double *d,
		double *d_pro_z,
		double *d_pro_z0);
void  georwi(	double x,
		double a,
		double y,
		double b,
		double thickness,
		double distance,
		double width,
		double *d,
		double *d_pro_z,
		double *d_pro_z0);
void  geohol(	double x,
		double a,
		double y,
		double b,
		double diameter,
		double radius,
		double *d,
		double *d_pro_z,
		double *d_pro_z0);
void rotate(	double phi,
		double x0,
		double y0,
		double *x1,
		double *y1);

/*  LSTMODE.C	*/

/*  MASDEF.C	*/
double masdef(	int z,
		int a);
double deform(	int z,
		int a);

/*  MATTER.C	*/
void matter(	double d_teilchen[],
		double i_am,
		int i_zm,
		double d_rho,
		int i_geo,
		double d_g1,
		double d_g2,
		double d_g3,
		double d_dx,
		double d_dy,
		double d_angle,
		double d_klwi,
		double d_enstr,
		double d_chstr,
		double d_lr,
		int *i_error);

  void table_cross(int i_zf,         
		   int i_qf,         
		   int i_zm,         
		   double  d_e,      
		   double  d_s[]);
  void read_table_cross( int    i_zp,
			 int    i_zt,
			 int    i_at,
			 double d_ap,
			 double dx);
    

/*  MATTER_.C	*/
void matter_(	int i_element,		/*aktuelle elementnummer*/
		double **d_data,	/*matter-daten*/
		double d_teilchen[],	/*teilchenkoordinaten*/
		int *i_error);

/*  MYMASS.C	*/
double mymass(	double z,
		double a);
double mydropm(	double z,
		double a);
double myshell(	double z,
		double a);
double mydefo (	double z,
		double a);
double myradp (	double z,
		double a);
double myradn (	double z,
		double a);
double mypair (	double z,
		double a);
double mybarr (	double z,
		double a);
double myfiss (	double z,
		double a);

/*  PLOTEW.C	*/
void plotew(	int *i_data,
		double **d_data,
		int i_tabewlen,
		int i_tabpllen,
		struct i_table *p_table);

/*  PRNTAB.C	*/
void prntab(	int i_tabewlen,
		int i_tabpllen,
		struct i_table *p_table,
		int i_umladmax);

/*  SAVTAB.C	*/
void savtab(	int i_tablen,
		double **d_erwtab,
		int i_umladmax,
		char *c_chargepat);

/*  SIBEAM.C	*/
void sibeam(	int i_element,
		int *i_data,
		double **d_data,
		double *d_teilchen,
		int *i_chpos,
		int i_z0,
		double d_a0);
/*
void sigen(	double mode,
		double *max_1,
		double max_2,
		double r12,
		double ver_1,
		double ver_2,
		double *ray1,
		double *ray2);
void siell6(	double ver_1,double max_1,
		double ver_2,double max_2,
		double ver_3,double max_3,
		double ver_4,double max_4,
		double ver_5,double max_5,
		double ver_6,double max_6,
		double *ray_1,double *ray_2,
		double *ray_3,double *ray_4,
		double *ray_5,double *ray_6);
void siell4(	double ver_1,double max_1,
		double ver_2,double max_2,
		double ver_3,double max_3,
		double ver_4,double max_4,
		double *ray_1,double *ray_2,
		double *ray_3,double *ray_4);
void siell8(	double ver_1,double max_1,
		double ver_2,double max_2,
		double ver_3,double max_3,
		double ver_4,double max_4,
		double *ray_1,double *ray_2,
		double *ray_3,double *ray_4);
*/
void siell9(	double ver_1,double max_1,
		double ver_2,double max_2,
		double ver_3,double max_3,
		double ver_4,double max_4,
		double ver_5,double max_5,
		double ver_6,double max_6,
		double *ray_1,double *ray_2,
		double *ray_3,double *ray_4,
		double *ray_5,double *ray_6);

/*  SIBRSL.C	*/
void sibrsl(	int i_element,
		double **d_data,	/*br-daten*/
		double *d_teilchen,	/*teilchenkoordinaten*/
		int *b_exist);		/*flag,'o'b = teilchen gestoppt*/

/*  SICOLL.C	*/
void sicoll(	int i_element,
		double **d_data,	/*collimatordaten*/
		double *d_teilchen,	/*teilchenkoordinaten*/
		int *b_exist);		/*flag,'o'b = teilchen gestoppt*/

/*  SICOOLER.C  */
void sicooler(  int i_element,
		double **d_data,
		double *d_teilchen,
		int *b_exist);



/*  SIDISTR.C	*/
void sidistr(	double d_ap,
		int i_zp,
		double d_at,
		int i_zt,
		double a,
		int i_z,
		double *yield);

/*  SIDRIFT.C	*/
void sidrift(	int i_element,
		double **d_data,
		double *d_teilchen);

/*  SIgasDRIFT.C	*/
void sigasdrift(
        int i_element,
        double **d_data,
        double *d_teilchen,
        int *i_error);

/* sidecay */
void sidecay(int i_element,
		   double **d_data,
		   double *d_teilchen,
		   int iflag);

/*  SIED.C	*/
void sied(	int i_at,
		int i_zt,
		double d_ap,
		int i_zp,
		double d_energy,
		double *d_si1,
		double *d_si2,
		double *d_sig_ed);
void ed(	double zp,
		double ap,
		double zt,
		double at,
		double elab,
		double *ce1,
		double *ce2,
		double *ce3);
double cross(	int l,
		double ap,
		double zp,
		double at,
		double zt,
		double gama);
double sum(	int l,
		double a,
		double z);

/*  SIELLI.C	*/
void siell6(	double ver_1,double max_1,double ver_2,double max_2,
		double ver_3,double max_3,double ver_4,double max_4,
		double ver_5,double max_5,double ver_6,double max_6,
		double *ray_1,double *ray_2,double *ray_3,double *ray_4,
		double *ray_5,double *ray_6);
void siell4(	double ver_1,double max_1,double ver_2,double max_2,
		double ver_3,double max_3,double ver_4,double max_4,
		double *ray_1,double *ray_2,double *ray_3,double *ray_4);
void siell8(	double ver_1,double max_1,double ver_2,double max_2,
		double ver_3,double max_3,double ver_4,double max_4,
		double *ray_1,double *ray_2,double *ray_3,double *ray_4);

/*  SIEND.C	*/
void siend();

/*  SIENVER.C	*/
void sienver(	double d_ap,
		int i_zp,
		int i_qp,    /* HWE */
		double d_en_anf,
		double d_at,
    //		int i_at,
		int i_zt,
		double d_weg,
		double *d_en_end,
		double d_chstr,
		int *i_error);
void sienver0(	double d_ap,
		int i_zp,
		double d_en_anf,
		double d_at,
     //		int i_at,
		int i_zt,
		double d_weg,
		double *d_en_end,
		int *i_error);
void sienver1(	double d_ap,
		int i_zp,
		int i_qp,    /* no. of electrons for chex */ 
		double d_en_anf,
		double d_at,
     //		int i_at,
		int i_zt,
		double d_weg,
		double *d_en_end,
		double d_chstr,
		int *i_error);

/*  SIENWI.C	*/
void sienwi(//	int i_at,
		double d_at,
		int i_zt,
		double d_d,
		double d_ap,
		int i_zp,
                int i_qp,               /* no. of electrons for chex */ 
		double *d_energy,       /*MeV/amu*/
		double *d_a,
		double *d_b,
		double d_klwi,
		double d_enstr,
		double d_chstr,
		double d_lr,            /*mg/cm**2*/
		int *i_error);

/*  SIEXIT.C	*/
void siexit(	int b_satan);

/*  SIFILE.C	*/
void sifile();

/*  SIGEN.C	*/
void sigen(	double mode,
		double max_1,
		double max_2,
		double r12,
		double ver_1,
		double ver_2,
		double *ray1,
		double *ray2);

/*  SIINIT.C	*/
void siinit(	int *i_data,
		double **d_data,
		char **c_mem,
		struct s_matrix **p_matrix,
		double *d_ebeam,
		double *d_dt,
		double *d_at,
		int *i_zt,
		double *d_sleng,
		char *c_mafile,
		int *i_ewumlad);
double sirale (	double d_a,
		int i_z);

/*  SIINIT1.C	*/
void siinit1(	int *i_data,
		double **d_data,
		double *d_ab,
		int *i_zbeam,
		int *l_beam,
		double *d_af0,
		int *i_zf0,
		int *i_turnm,
		struct i_table *p_table,
		int *i_tabewlen,
		int *i_tabpllen,
		int *i_spalt,
		int *i_primturn,
		int *i_primcharge,
		int *i_umladmax,
		int *i_chargemax,
		int *i_ewmax,
		double d_e_beam);

/*  SIKOX1.C	*/
double sikox1(	double d_ap,
		double d_at,
		double d_energy);

/*  SIMAIN.C	*/
int simain(     char *filename);
/*  SIMASS.C	*/
double simass(	int i_z,
		int i_a,
		int mode);

/*  SIMULT.C	*/
void simult(	double *d_teilchen,
		struct s_matrix **p_matrix,
		int    i_element,
		double **d_data);

/*  SIPRMA.C	*/

/*  SIRAND.C	*/
void sirand(	int i_element,
		double **d_data,
		double *d_teilchen);

/*  SIRANGE.C	*/
double sirange(	double d_ap,
		int i_zp,
		double d_energy,
		double d_at,
		int i_zt);

double sirange0(	double d_ap,
		int i_zp,
		double d_energy,
		double d_at,
		int i_zt);

double sirange1(	double d_ap,
		int i_zp,
		double d_energy,
		double d_at,
		int i_zt);

/*  SIREAD.C	*/
void siread(	char *c_header,
		char *c_dsn_out,
		int *i_data,
		double **d_data,
		char **c_mem,
		struct i_table **p_table,
		char *c_mafile,
		int *i_fraglist,
		int *i_z_all,
		double *d_a_all,
		char *erwa_name[ERWA_MAX],
                double *d_e1_all,
                double *d_e2_all);

/*  SIREFI.C	*/
void sirefi(	int i_element,
		double **d_data,
		double *d_teilchen,
		int *b_finish);

/*  SIREMA.C	*/
int sirema(	struct s_matrix **p_matrix,
		char *c_mem,
		double *d_l,
		char *c_mafile,
		int i_order);
void sigisi(	double **d_gmatrix,
		double **d_simatrix,
		double d_length);
  void siconv(	double **d_simatrix,
		int matrix_size);
double f(	int i);
int  ar(	int i);
int  gicoar(	int i);

/*  SIRERA.C	*/
double sirera(	int i_at,
		int i_zt);
double sirera0(	int i_at,
		int i_zt);
double sirera1(	int i_at,
		int i_zt);
double sirera2(	int i_at,
		int i_zt);

/*  SIRESET.C	*/
void sireset(	double *d_teilchen);

/*  SISATAN.C	*/
void sisatan(	int i_element,
		double **d_data,
		int *b_satan,
		char *c_dsn_out,
		char *c_header);

/*  SISAVE.C	*/
void sisave(	double *d_teilchen);

float sisigan(
	double d_ap,        /* mass of projectile */
	int i_zp,           /* charge of projectile */
	double d_en_in,     /* energy of projectile in front of material */
	double d_en_out,    /* energy of projectile behind material */
	double d_at,           /* mass number of target */
	int i_zt);           /* charge of target */

float sisigen(
	double d_ap,        /* mass of projectile */
	int i_zp,           /* charge of projectile */
	double d_en_in,     /* energy of projectile in front of material */
	double d_en_out,    /* energy of projectile behind material */
	double d_at,           /* mass number of target */
	int i_zt);           /* charge of target */

/*  SISIGRA.C	*/
void sisigra(	double d_ap,
		int i_zp,
		double d_energy,
		double d_at,
		int i_zt,
		double *d_range,
		double *d_sigra);
void sisigra0(	double d_ap,
		int i_zp,
		double d_energy,
		double d_at,
		int i_zt,
		double *d_range,
		double *d_sigra);
void sisigra1(	double d_ap,
		int i_zp,
		double d_energy,
		double d_at,
		int i_zt,
		double *d_range,
		double *d_sigra);

/*  SISTOP.C	*/
void sistop(	int i_element,
		int *i_data,
		double **d_data,
		double *d_teilchen);

/*  SITURN.C	*/
void siturn(	double d_af0,
		int i_zf0,
		int i_turnm,
		double d_ab,
		int i_zbeam,
		double *d_a_all,
		int *i_z_all,
		int *i_fmax,
		int *i_primturn,
		int i_fraglist,
		int i_spalt,
		int *i_error);

/*  SIWEDGE.C	*/
void siwedge(	int i_element,		/*aktuelle elementnummer*/
		double **d_data,	/*keildaten*/
		double *d_teilchen,	/*teilchenkoordinaten*/
		int *i_error);

/*  SIWENR.C	*/
void siwenr(	double d_af,
		int i_zf,
		double d_at,
		int i_zt,
		double d_dw,
		double d_enstr,
		double *d_energy);

/*  SIWRITE.C	*/
void siwrite(	char *c_header,
		char *c_dsn_out,
		int *i_data,
		double **d_data,
		struct s_matrix *p_matrix[],
		char *c_mem[],
		int i_tabewlen,
		char *c_mafile,
		char *erwa_name[ERWA_MAX],
	        int i_z_all[],
	        double d_a_all[]);
void siprma(	struct s_matrix *p_matrix,
		int i_order);

/*  TACROSS.C	*/
void tacross(	double d_energyb,
		double d_ab,
		int i_zb,
		double d_dt,
		double d_at,
		int i_zt,
		double d_a_all[],
		int i_z_all[],
		int i_fmax,
                int mode);

/*  TARGET_.C	*/
void target_(	
		int i_element,		/*aktuelle elementnummer*/
		double **d_data,	/*targetdaten*/
		double *d_teilchen,	/*teilchenkoordinaten*/
		double  d_af,
		int i_zf,
		int i_fragment,
		int *i_error,
		double d_e1,
		double d_e2);

int reaction_inelastic_scattering(double *in, double ex3, double ex4,
				  double thmin, double thmax, int i_zp, 
				  double d_ap, int i_zt, double d_at,
				  int i_zf, double d_af);
int reaction_fusion(double *in, double ex3, double ex4, double thmin, 
		    double thmax, int i_zp, double d_ap, int i_zt, double d_at,
		    int i_zf, double d_af,int i_distr);
int reaction_fusion_fission(double *in, double ex3, double ex4,
			    double thmin, double thmax, int i_zp, 
			    double d_ap, int i_zt, double d_at,
			    int i_zf, double d_af,int i_distr,
			    double d_gold);
int reaction_radiative_capture(double *in, double ex3, double ex4,
			       double thmin, double thmax, int i_zp, 
			       double d_ap, int i_zt, double d_at,
			       int i_zf, double d_af,int i_distr);
  

/*  TARGET_.C	*/
void reaction_target(	
		int i_element,		/*aktuelle elementnummer*/
		double **d_data,	/*targetdaten*/
		double *d_teilchen,	/*teilchenkoordinaten*/
		double  d_af,
		int i_zf,
		int i_fragment,
		int *i_error);

/*  UEBERL.C	*/
double ueberl(	double d_af,		/* masse des fragmentes*/
		int i_zf,		/* kernladung des fragmentes*/
		int i_aw,		/* masse der materie*/
		int i_zw,		/* kernladung der materie*/
		double d_dw,		/* dicke der materie*/
		double d_energy0,	/* eingengsenergie*/
		double d_energy);	/* ausgangsenergie*/

int   fragmentation_init(int i_zb,double d_ab,int i_zt,double d_at,
                         double thickness, double d_energy);
double  fragmentation_total_yields(int zp, int ap, int i_zt, int d_at, double thickness,
                                   double energy);
void  fragmentation(int zp, int ap, int i_zt, int d_at, double thickness,
		    int *zf, int *af, double energy);

/* AUDIMASS.C */
int read_audi_table(char *);
void setmymass(int i_z,int i_a,double d_a);
double audi_mass(int i_z,int i_a);
 
/*root.cc*/
  void initialize_root(void);
  int open_root(char *filename);
  void close_root(void);
  int open_root_tree(void);
  void write_root_tree(void);
  void close_root_tree(void);
  void mhbook1(int id, char *title, int bin, double xmin, double xmax);
  void mhbook2(int id, char *title,int xbin,double xmin,double xmax,
	       int ybin,double ymin,double ymax);
  void mhf1(int id,double x, double w);
  void mhf2(int id,double x, double y, double w);
  int open_root_ntuple(int id,char *title);
  void write_root_ntuple(int id,float *f_teilchen);
  void close_root_ntuple(void);
  double mmbsk0(int i,double d,int *iret);
  double mmbsk1(int i,double d,int *iret);
  int open_root_tree_read(int id,char *filename,int read_file_isave);
  void read_root_tree(int id,float *f_teilchen,int read_file_isave,
			int *iloop, int no_of_entry);
  void mocadi_abort(int ret);

  /* csd_equilib.c  */
  void csd_equilib(double d_energy, int i_zf, int i_zm, int n, double *f);
  
  /* gl_bipoco.c */
  void bipoco1s(double X, double CX, double ETH, double THE, double Z, double *BP);
  void bipoco2s(double X, double CX, double ETH, double THE, double Z, double *BP);
  void bipoco2p(double X, double CX, double ETH, double THE, double Z, double *BP);
  double fnpol(double X);
  double pow_int(double par, int power);
  
  /*gl_capcross.c*/
  void capcross(double ZP, double ZT, double *SC, int *IRC );
  void reccork(double Z, double U, double *SRKBEST, int *IRC );
  void reccorlm(double U, double *SRL, double *SRM, int *IRC );

  /*gl_cross*/
  void global_cross(int i_zf, int ne, int i_zm, double EN, double *d_s);

  /*gl_intpoklm.c*/
  double ffintpol(double ETHH, double THE,
		  double TH1,  double TH2,
		  double ETH1, double ETH2,
		  double F1, double F2, double F3);

  double frint1d ( double X, double *XTAB, double *YTAB, int N );
  double frint1dl( double X, double *XTAB, double *YTAB, int N );
  void intpoklm(double ETHH, double THE, double Z, double U, char *CFILE,
		double *SI, double *RTR, double *PP, int *IRC);
  double pow2(double par);

  /*gl_ionicro.c*/
  void ionicro(double ZF, double U1S, double U1SS, double U2S,
	       double U2P, double U3S, double U3D, int *IRC2);






/*
#define d_aver(a,b,c,d) d_aver[(((a*i_chbnd+b)*14+c)*i_ewmax+d)]
#define i_number(a,b)   i_number[(a*i_ewmax)+b]
#define d_erwtab(a,b)   d_erwtab[(a*3)+b]
*/

#ifdef __cplusplus
}
#endif
