#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "atima.h"
#include "mocadi.h"

void sienver1(	
	      double d_ap,		/* mass   of projectile */ 
	      int i_zp,			/* charge of projectile */
	      int i_qp,			/* number of electrons  */
	      double d_en_anf,	        /* energy of projectile */
	      double d_at,		/* mass   of target     */
     //	      int i_at,			/* mass   of target     */
	      int i_zt,			/* charge of target     */
	      double d_weg,		/* thickness of target  */
	      double *d_en_end,         /* energy of ejectile   */
	      double d_chstr,           /* charge-exchange straggling flag */ 
	      int *i_error)		/* 0:alive,1:stoped     */
{ 
 
 /*******************************************************************/
 /*                                                                 */
 /* this function calculates the energy loss of a particle with     */
 /* mass i_ap and charge i_zp with energy i_en_anf when it traverses*/
 /* a target with (d_at,d_zt) of thickness d_weg.                   */
 /*                                                                 */
 /* alle external-felder muessen vorher besetzt sein                */
 /*            besetzen mit : call sirera                           */
 /*                                                                 */
 /*******************************************************************/
  extern int i_asave[I_SAVE_MAX+1];
  extern int i_zsave[I_SAVE_MAX+1];
  extern double d_asave[I_SAVE_MAX+1];
  extern int i_fsave[I_SAVE_MAX+1];
  extern struct splines atima_spline[120][I_SAVE_MAX+1];
  extern char MOCADI_SPLINES_GZ[] ; // HWE
  extern int b_check;
  double  d_range;
  double d_thick;
  double gamma,beta,dedx,dedx1,dedx2;
  double d_zmean1,d_zmean2,d_zmean,d_eloss,d_en_mean; // HWE
  int i_save,i_at; 
 
  i_at=d_at+0.5;

  *i_error = 0;
 
  if(b_check)printf("   sienver: sienver wird abgearbeitet\n");
  //  if(b_check)printf(" Z=%d A=%lf\n",i_zt, d_at); 
  d_thick=d_weg;

  for(i_save = 1;i_save <=I_SAVE_MAX;i_save++){ /*tabelle schon gespeichert*/
    if ((i_zsave[i_save]  > 200 )&&(i_zsave[i_save] == i_zt))goto L1;
/*    if ((i_asave[i_save] == i_at)&&(i_zsave[i_save] == i_zt))goto L1;*/
    if (i_zsave[i_save] == i_zt){
//      d_thick = d_weg * simass(i_zt,i_asave[i_save],0)/simass(i_zt,i_at,0);
      if(fabs(d_at)>1e-6)   //&&fabs(d_at-d_asave[i_save])>1e-2)
	d_thick = d_weg * d_asave[i_save]/d_at;
      else
	d_thick = d_weg;	
      //      printf("sienver: Ain=%lf,Asp=%lf,thickness=%lf, calcthickness=%lf\n",
      //	     d_at, simass(i_zt,i_asave[i_save],0),d_weg,d_thick);
      goto L1;
    }
  }
/*  printf("**SIENVER ERR* system error\n"); */
  printf("The matter(Z=%d,A=%d) doesn't exist in stored list\n",i_zt,i_at);
  mocadi_abort(-63);
L1: 

  if(i_zp<=92||(i_fsave[i_save]==0 && i_zp<=120)){
    
    /* make a first fast energy-loss calculation to decide which formula to use */
    dedx1 = atima_dedx(&atima_spline[i_zp-1][i_save],d_en_anf);
    *d_en_end = d_en_anf - dedx1 / d_ap * d_thick ;

    /* for thin target use dedx * thickness, else spline differences */
    if(1 - *d_en_end/d_en_anf < 1e-3) { 
      /*  calculate final energy with dedx and mean charge(Z) */
      if (fabs(d_chstr) < 0.5) {
	dedx2 = atima_dedx(&atima_spline[i_zp-1][i_save],*d_en_end); 
        dedx = (dedx1 + dedx2)/2 ;
        *d_en_end = d_en_anf - dedx /d_ap * d_thick ;
	//printf("%f %f %f %f %f\n",dedx1,dedx2,dedx,d_en_anf,*d_en_end);
      }
      /* calculate final energy with dedx from special splines */
      else if(fabs(d_chstr) > 1.5){
        dedx1 = atima_dedx(&atima_spline[i_zp-i_qp-1][i_save],d_en_anf); 
	dedx2 = atima_dedx(&atima_spline[i_zp-i_qp-1][i_save],*d_en_end); 
        dedx = (dedx1 + dedx2)/2 ;
        *d_en_end = d_en_anf - dedx /d_ap * d_thick ;
	//printf("%f %f %f %f %f q_i=%d\n",dedx1,dedx2,dedx,d_en_anf,*d_en_end,i_zp-i_qp);
      }
      /* calculate final energy with dedx scaled in (q_i/q_eff)^(2*corr) */
      else {
	dedx1 = atima_dedx(&atima_spline[i_zp-1][i_save],d_en_anf) ; 
	dedx2 = atima_dedx(&atima_spline[i_zp-1][i_save],*d_en_end) ;
	dedx = (dedx1 + dedx2)/2 ;
        *d_en_end = d_en_anf - dedx /d_ap * d_thick ;
	d_en_mean = (*d_en_end + d_en_anf)/2 ;             // HWE

	if(strcmp(MOCADI_SPLINES_GZ,"/u/weick/mocadi/splines_gz_1.4/")==0){
          d_zmean = atima_qmean(&atima_spline[i_zp-1][i_save],d_en_mean);  /* mean charge like in atima 1.4, HWE */
        }
	else {
	  gamma = 1. + d_en_mean / d_amu ;                           /* average velocity over target thickness */
          beta = sqrt(1.-1./(gamma*gamma));
          d_zmean = i_zp * (1 - exp(-130*beta/pow(i_zp,0.6666)));         /* mean charge like in atima 1.3 */
        }
	dedx = dedx * pow((i_zp-i_qp)/d_zmean,2*fabs(d_chstr)) ;   // HWE
        *d_en_end = d_en_anf - dedx /d_ap * d_thick ;                /* corrected energy loss */
      }	
    }
    else {   /* for thick targets */
      /*  calculate final energy with mean charge(Z) */
      if (fabs(d_chstr) < 0.5) {
        *d_en_end = atima_enver(&atima_spline[i_zp-1][i_save], d_en_anf, 
         	    d_thick*atima_spline[i_zp-1][i_save].m_projectile/d_ap);
      }
      /* calculate final energy with individual charge directly in special splines */
      else if(fabs(d_chstr) > 1.5){
        *d_en_end = atima_enver(&atima_spline[i_zp-i_qp-1][i_save], d_en_anf, 
        	    d_thick*atima_spline[i_zp-i_qp-1][i_save].m_projectile/d_ap);
      }
      /* calculate final energy with individual charge scaled in q^(2*corr) */
      else {
        *d_en_end = atima_enver(&atima_spline[i_zp-1][i_save], d_en_anf, 
           	    d_thick*atima_spline[i_zp-1][i_save].m_projectile/d_ap);
        d_en_mean = (*d_en_end + d_en_anf)/2.;            // HWE
	
        //printf(">%s< %d\n",MOCADI_SPLINES_GZ,strcmp(MOCADI_SPLINES_GZ,"/u/weick/mocadi/splines_gz_1.4/"));	
	if(strcmp(MOCADI_SPLINES_GZ,"/u/weick/mocadi/splines_gz_1.4/")==0){
          d_zmean = atima_qmean(&atima_spline[i_zp-1][i_save],d_en_mean); /* mean charge like in atima 1.4, HWE */
        }  
	else{
          gamma = 1. + d_en_mean / d_amu ;               /* average velocity over target thickness */
          beta = sqrt(1.-1./(gamma*gamma));
          d_zmean = i_zp * (1 - exp(-130*beta/pow(i_zp,0.6666)));     /* mean charge like in atima 1.3 */
        }	
        d_eloss = (d_en_anf - *d_en_end) * pow((i_zp-i_qp)/d_zmean,2*fabs(d_chstr)) ; /* corrected energy loss */
        *d_en_end = d_en_anf - d_eloss ;
      }
    }
  }  
  /* transuranium case, simple Z^2 extrapolation */  // HWE remove, now part of ATIMA since 1.3
  else {
    *d_en_end=atima_enver(&atima_spline[92-1][i_save], d_en_anf, 
       	      d_thick*atima_spline[92-1][i_save].m_projectile/d_ap);
    d_eloss = (d_en_anf - *d_en_end) * pow(i_zp/92.,2) ; 
    *d_en_end = d_en_anf - d_eloss ;
  }


  if(*d_en_end<=0)*i_error=1;
}
