#include <stdio.h>
#include <stdlib.h>
#include <string.h>
/*
#include <unixio.h>
#include <file.h>
*/
#include "atima.h"
#include "mocadi.h"

static char *nuclei_name[120]={
  "H1"   ,"He4"    ,"Li7"  ,  "Be9"  ,  "B10"  ,
  "C12"  ,"N14"    ,"O16"  ,  "F19"  ,  "Ne20" ,
  "Na23" ,"Mg24"   ,"Al27" ,  "Si28" ,  "P31"  ,
  "S32"  ,"Cl36"   ,"Ar40" ,  "K39"  ,  "Ca40" ,
  "Sc45" ,"Ti48"   ,"V51"  ,  "Cr52" ,  "Mn55" ,
  "Fe56" ,"Co60"   ,"Ni58" ,  "Cu63" ,  "Zn65" ,
  "Ga70" ,"Ge74"   ,"As75" ,  "Se80" ,  "Br80" ,
  "Kr84" ,"Rb85"   ,"Sr88" ,  "Y90"  ,  "Zr91" ,
  "Nb93" ,"Mo96"   ,"Tc99" ,  "Ru101",  "Rh103",
  "Pd106","Ag107"  ,"Cd114",  "In115",  "Sn119",
  "Sb121","Te130"  ,"I127" ,  "Xe132",  "Cs133",
  "Ba138","La139"  ,"Ce140",  "Pr141",  "Nd144",
  "Pm147","Sm152"  ,"Eu153",  "Gd158",  "Tb159",
  "Dy162","Ho165"  ,"Er167",  "Tm169",  "Yb173",
  "Lu175","Hf178"  ,"Ta181",  "W184" ,  "Re186",
  "Os190","Ir192"  ,"Pt195",  "Au197",  "Hg200",
  "Tl204","Pb207"  ,"Bi209",  "Po210",  "At210",
  "Rn222","Fr223"  ,"Ra226",  "Ac227",  "Th232",
  "Pa231","U238"   ,"Np237",  "Pu241",  "Am243",
  "Cm246","Bk247"  ,"Cf250",  "Es253",  "Fm251",
  "Md252","No255"  ,"Lr255",  "Rf259",  "Db259",
  "Sg263","Bh265"  ,"Hs268",  "Mt274",  "Ds279",
  "Rg280","Cn283"  ,"113X284","Fl287",  "115X289",
  "Lv292","117X293","118X294","119X295","120X297"  };

static char *target_name[99]={
  "H" ,"He","Li","Be","B" ,
  "C" ,"N" ,"O" ,"F" ,"Ne",
  "Na","Mg","Al","Si","P" ,
  "S" ,"Cl","Ar","K" ,"Ca",
  "Sc","Ti","V" ,"Cr","Mn",
  "Fe","Co","Ni","Cu","Zn",
  "Ga","Ge","As","Se","Br",
  "Kr","Rb","Sr","Y" ,"Zr",
  "Nb","Mo","Tc","Ru","Rh",
  "Pd","Ag","Cd","In","Sn",
  "Sb","Te","I" ,"Xe","Cs",
  "Ba","La","Ce","Pr","Nd",
  "Pm","Sm","Eu","Gd","Tb",
  "Dy","Ho","Er","Tm","Yb",
  "Lu","Hf","Ta","W" ,"Re",
  "Os","Ir","Pt","Au","Hg",
  "Tl","Pb","Bi","Po","At",
  "Rn","Fr","Ra","Ac","Th",
  "Pa","U" ,"Np","Pu","Am",
  "Cm","Bk","Cf","Es"};

static char *ctarget_name[20]={
  "plastic","air",       "PE",      "liq.Hydrogen", "liq.Deuterium", 
  "water",  "diamond",   "glass",   "AlMg3",        "Ar_CO2_30",
  "CF4",    "Isobutan",  "Kapton_H","Mylar",        "NaF",
  "P10_gas","Polyolefin","CmO2",    "Suprasil2",    "HAVAR"};


double sirera1(int i_at,int i_zt)
{
  /*******************************************************************/
  /*                                                                 */
  /* read range values from file "TAB#xx.DATA" (format-free)         */
  /* only ranges are read that are used later in the program for     */
  /* Z-values from i_z_min to i_z_max.                               */
  /*                                                                 */
  /*******************************************************************/
 
  int	i_n;			/*anzahl der z-werte*/
  static int i_save=0;
  extern int i_asave[I_SAVE_MAX+1], i_zsave[I_SAVE_MAX+1],
    i_fsave[I_SAVE_MAX+1];
  extern double d_asave[I_SAVE_MAX+1];
  extern int b_check;
 
  int i,j; 
 
  static char line[STRING_SIZE];
  extern FILE *out;
  extern struct splines atima_spline[120][I_SAVE_MAX+1];
  extern char MOCADI_SPLINES[];
  double msum,nsum;
  
  
  if( b_check )printf("  sirera : sirera wird abgearbeitet\n");
  if( b_check )printf("%d %d\n",i_at,i_zt);

  for(i = 1;i<=i_save;i++){
/*    if ( (i_asave[i] == i_at)&&(i_zsave[i] == i_zt)) return;*/
    if (i_zsave[i] == i_zt) return(d_asave[i]);
  }
 
  i_save++;
  if (i_save == I_SAVE_MAX+1){
    fprintf(out,"**SIRERA ERR*MOCADI can treat only %d matters!! \n",
	    I_SAVE_MAX);
    mocadi_abort(-75);
  }
  
  i_asave[i_save] = i_at;
  i_zsave[i_save] = i_zt;
  i_fsave[i_save] = 0;
  
  if(i_zt>0&&i_zt<=99){
    for(i=0;i<120;i++){
      sprintf(line,"%s%s-%s.dat",MOCADI_SPLINES,nuclei_name[i],
	      target_name[i_zt-1]);
      if(get_atima_spline(line,&atima_spline[i][i_save])<0){
	if(i<92){
	  printf("cannot open file %s \n", line);
	  mocadi_abort(-75);
	}
	else{
	  if(i_fsave[i_save]==0){
	    printf("Please install new spline files (mocadi-data-35.tgz) to your PC.\n");
	    i_fsave[i_save]=1;
	  }
	}
      }
    }
    sprintf(line,"<I> read ATIMA splines for %s.",target_name[i_zt-1]);
    i_asave[i_save] = atima_spline[1][i_save].m_target[0] +0.5;
  }
  else if(i_zt>= 201 && i_zt<=220){
    for(i=0;i<120;i++){
      sprintf(line,"%s%s-%s.dat",MOCADI_SPLINES,nuclei_name[i],
	      ctarget_name[i_zt-201]);
      if(get_atima_spline(line,&atima_spline[i][i_save])<0){
	if(i==203){
	  sprintf(line,"%s%s-pe.dat",MOCADI_SPLINES,nuclei_name[i]);
	  if(get_atima_spline(line,&atima_spline[i][i_save])>=0)
	    goto next;
	}
	if(i<92){
	  printf("cannot open file %s \n", line);
	  mocadi_abort(-75);
	}
	else{
	  if(i_fsave[i_save]==0){
            printf("Please install new spline files (mocadi-data-35.tgz) to your PC.\n");
            i_fsave[i_save]=1;
          }
	}
      }
    next:;
    }
    sprintf(line,"<I> read ATIMA splines for %s.",ctarget_name[i_zt-201]);
  }
  else{
    printf(" sirera1: *** table not implemented up to now ***");
    printf("i_at = %4d i_zt = %4d\n",i_at,i_zt);
    mocadi_abort(-75);
  }       
  puts(line);
  msum=nsum=0;
  for(i=0;i<atima_spline[1][i_save].n_nuc;i++){
    printf("%d: Z=%d, A=%f, w=%f, pot=%f\n",
	   i+1,
	   atima_spline[1][i_save].z_target[i],
	   atima_spline[1][i_save].m_target[i],
	   atima_spline[1][i_save].count[i],
	   atima_spline[1][i_save].pot[i]);
    msum+=atima_spline[1][i_save].m_target[i]*atima_spline[1][i_save].count[i];
    nsum+=atima_spline[1][i_save].count[i];
  }	 
  if(nsum<1e-6) msum=0;
  else msum=msum/nsum;
  d_asave[i_save]=msum;
  return(msum);
/*
ERROR:
  printf("Error*sirera #1*file error for frein\n");
  mocadi_abort(-75);
*/
}
