#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "atima.h"
#include "mocadi.h"
float sisigen(	
		double d_ap,	    /* mass of projectile */
		int i_zp,	    /* charge of projectile */
		double d_en_in,     /* energy of projectile in front of material */
		double d_en_out,    /* energy of projectile behind material */
		double d_at,           /* mass number of target */
		int i_zt)           /* charge of target */
{
 /*******************************************************************/
 /*                                                                 */
 /* this function calculates the energy straggling of a particle    */
 /* with mass i_ap and charge i_zp with energy i_en_anf when it     */
 /* traverses a target with (d_at,d_zt)                             */
 /*                                                                 */
 /* all external-felder muessen vorher besetzt sein                 */
 /*            besetzen mit : call sirera                           */
 /*                                                                 */
 /*******************************************************************/
  extern int i_asave[I_SAVE_MAX+1];
  extern int i_zsave[I_SAVE_MAX+1];
  extern int i_fsave[I_SAVE_MAX+1];
  extern struct splines atima_spline[120][I_SAVE_MAX+1];
  extern int b_check;
  double  d_range;
  int i_save; 
  double s1,s2,dedx, estragg;
  
  if(b_check)printf("   sisigen: sisigen is working\n");
 
  for(i_save = 1;i_save <=I_SAVE_MAX;i_save++){ /*tabelle schon gespeichert*/
    if ((i_zsave[i_save] >  200 )&&(i_zsave[i_save] == i_zt))goto L1;
    if (i_zsave[i_save] == i_zt)goto L1;
  }
  printf("**SISIGEN ERR* system error\n");
  printf("The matter(Z=%d,A=%lf) doesn't exist stored list\n",i_zt,d_at);
  mocadi_abort(-78);
L1:

  /* avoid error for transuranium cases, scaling would be better, remove for full spline set!!! */
  if(i_fsave[i_save]==0){
    if(i_zp>120) i_zp=120 ;
  }
  else if(i_fsave[i_save]==1){
    if(i_zp>92) i_zp=92 ;
  }
  
  /* for thin target use dOmega2/dE * dE, else spline differences */
  if(1. - d_en_out/d_en_in < 1e-3) {  
    s1 = atima_domega2de(&atima_spline[i_zp-1][i_save], d_en_in) * (d_en_in-d_en_out)
    	*(d_ap/atima_spline[i_zp-1][i_save].m_projectile);
    s2 = atima_domega2de(&atima_spline[i_zp-1][i_save], d_en_out)* (d_en_in-d_en_out)
    	*(d_ap/atima_spline[i_zp-1][i_save].m_projectile);
    dedx = atima_dedx(&atima_spline[i_zp-1][i_save],d_en_out);
    estragg = dedx * sqrt((s1+s2)/2.) ;
  }
  else{
    s1 = atima_sigra2(&atima_spline[i_zp-1][i_save],d_en_in)
  	 *(d_ap/atima_spline[i_zp-1][i_save].m_projectile);
    s2 = atima_sigra2(&atima_spline[i_zp-1][i_save],d_en_out)
  	 *(d_ap/atima_spline[i_zp-1][i_save].m_projectile);
    dedx = atima_dedx(&atima_spline[i_zp-1][i_save],d_en_out);
    estragg = dedx * sqrt(s1-s2) ;
  }

  //printf("***SISIGEN**\n Ap=%lf Zp=%d Ein=%lf sig_E=%lf At=%d Zt=%d\n",d_ap,i_zp,d_en_in,estragg,i_at,i_zt);

  return(estragg);
}
